// $Id: links.h,v 1.8 2002/11/12 23:11:43 toast Exp $

#ifndef _LINKS_H_
#define _LINKS_H_

#include <string>
#include <list>

#include "strtype"

class Links
{
private:
  std::string Name;		// "Root" server's name
  std::list<Links> Children;	// Linked children
public:
  Links();			// Constructor
  Links(const std::string &);	// Constructor
  ~Links();			// Destructor
  void Clear();			// Clear everything
  bool Exists(const std::string &);	// Is server somewhere
					// in the tree?
  bool Link(const std::string &, const std::string &);	// Connect a
					// server somewhere in
					// a tree
  bool Unlink(const std::string &);	// Disconnect a server from
				// the tree
  void SetName(const std::string &);	// Set the root's name
  std::string GetName() const	// Get the root's name
    { return Name; }
  void GetTree(StrList &, const std::string &);	// Get the tree in list form
  void GetLinks(StrList &, const std::string &);
};

#endif
