// $Id: log.cc,v 1.5 2002/11/10 22:01:40 toast Exp $

#include <fstream.h>
#include <string>

#include "oomon.h"
#include "log.h"
#include "config.h"
#include "main.h"
#include "util.h"

ofstream Log::logfile;
bool Log::IsOpen = false;

void Log::Start()
{
  if (!IsOpen) {
    #ifdef LOG_DEBUG
      cout << "Opening log file for append" << endl;
    #endif
    logfile.open(Config::GetLogFile().c_str(), _IO_APPEND);
    IsOpen = true;
  }
}

void Log::Write(const std::string & Text)
{
  if (IsOpen)
    logfile << '[' << TimeStamp() << "] " << Text << endl;
}

void Log::Stop()
{
  if (IsOpen) {
    #ifdef LOG_DEBUG
      cout << "Closing log file" << endl;
    #endif
    logfile.close();
    IsOpen = false;
  }
}
