// $Id: oomon.h,v 1.49.2.2 2003/01/18 17:20:32 toast Exp $

#ifndef _OOMON_H_
#define _OOMON_H_

#include "defs.h"

#ifdef HAVE_CRYPT_H
# include <crypt.h>
#endif

//   Confused?  Visit the following URL:
//
//      http://toast.blackened.com/oomon/oomon_h.html


#ifdef DEBUG
# define CONFIG_DEBUG
# define IRC_DEBUG
# define DCC_DEBUG
# define REMOTE_DEBUG
# define REMOTELIST_DEBUG
# define ENGINE_DEBUG
# define LOG_DEBUG
# define KLINES_DEBUG
# define LINKS_DEBUG
# define PROXY_DEBUG
#endif

// This is the configuration file
#define DEFAULT_CFGFILE		"oomon.cf"

// Where to store the process id number
#define DEFAULT_PIDFILE		"oomon.pid"

// Default help filename
#define DEFAULT_HELPFILE	"oomon.help"

// I like to fork.  Do you like to fork?  Everybody likes to fork!
// Not recommended for use when debugging.
#ifndef DEBUG
# define FORK_OOMON
#endif

// Define this if you want to use encrypted passwords
#define USE_CRYPT

// Define this if you are using comstud's new ircd
#undef USE_FLAGS

// Define this if you want temporary *@host.domain.com klines
// added automatically (I recommend this not be used)
// Pros: dynamic ip floodclones with changing usernames (with
//       identd) klined
// Cons: shell servers with multiple connections might be klined
//       if they all connect in a short period of time
#undef AUTO_KLINE_HOST

// Define this if you want ~*@*.domain.com klines added automatically
// Pros: floodclones without identd are quickly removed
// Cons: Might take out more users than desired
#define AUTO_KLINE_NOIDENT

// Define this if you want *user@*.domain.com klines added
// automatically
// Pros: very useful
// Cons: dunno
#define AUTO_KLINE_USERHOST

// Define this if your ircd matches clients' IPs against K-lines, along
// with their hostnames.
#undef KLINE_IP_SUPPORTED

// Define this if you don't want unauthorized people connecting to the
// bot via DCC.  Note that the CTCP CHAT command is ALWAYS oper-only.
// Use this to prevent users from getting your OOMon's IP address!
#define ONLY_OPERS_MAY_DCC

// Define this if you want the nick of the oper who is issuing a kline to
// be included in the kill/kline/dline/etc. reason.
#undef OPER_NICK_IN_REASON

// Set this to true if you want it on when the bot starts up or false
// if you want it off when it starts up.
#define AUTOPILOT_DEFAULT	true

// Minimum number of user@host duplicates to report when using the
// .multi, .umulti, and .hmulti commands
#define MULTI_MINIMUM		3

// Define this if you don't want opers to show up in .multi output
#define NO_OPERS_IN_MULTI

// Define this if you want to watch TRACE requests.  Not recommended
// on servers that allow bots.
#undef TRACE_BASTARD

// Define this if you want users to be notified of any connected OOMon
// opers when a /STATS P is performed
#define SHOW_STATSP

// Define this if you want /stats P requests to be considered equivalent
// to /stats p requests.  On some servers, /stats P shows ports the ircd
// is listening to, not the currently active operators.
#undef STATS_P_CASE_INSENSITIVE

// Define this if you want each oper's user@host to be displayed when
// a user does a /STATS P
#define SHOW_STATSP_USERHOST

// Define this if you want each oper's idle time to be displayed when
// a user does a /STATS P
#define SHOW_STATSP_IDLE

// Define this to be the the kill reason to use if no reason is 
// provided when using the killlist command.
#define DEFAULT_KILLLIST_REASON	"Too many connections, read MOTD"



// Define this if you want to allow users who haven't auth'ed to chat
// on the bot.
#undef UNAUTHED_MAY_CHAT



// Define this to detect vhost clones
#define DETECT_VHOST_CLONES

// Netmask used for detecting vhosts (warning: do not change!)
#define VHOST_NETMASK "255.255.255.0"

#define MAX_IP_CONNECTS 5
#define MAX_IP_TIME 10


// Define this if you want to match connecting clients against a
// DNSBL-based proxy list.  Highly recommended!
// Pros: may catch stuff oomon doesn't
// Cons: DNS lookups could slow down oomon
#define PROXY_BLACKHOLE_ZONE	"opm.blitzed.org."

// Set this to the number of minutes to kline DNSBL proxies or 0 if
// you don't want it to use temporary klines
#define DNSBL_KLINE_TIME	0


// Watch for open WinGate users
#define DETECT_WINGATES

// Define this to automagically dline or kline wingates
//   (DLINE has precedence over KLINE)
#undef AUTO_DLINE_WINGATES
#define AUTO_KLINE_WINGATES

// Set this to the number of minutes to kline wingates or 0 if you
// don't want it to use temporary klines
#define WINGATE_KLINE_TIME	0



// Watch for open SOCKS proxy users
#define DETECT_PROXIES

// Define this to automagically dline or kline proxies
//   (DLINE has precedence over KLINE)
#undef AUTO_DLINE_PROXIES
#define AUTO_KLINE_PROXIES

// Set this to the number of minutes to kline proxies or 0 if you
// don't want it to use temporary klines
#define PROXY_KLINE_TIME	0



// Use the teletype nick change format
#undef TELETYPE_NIH

// Don't suggest klines for E: lines in config file
#define DONT_KLINE_OUR_E

// Controls whether bot should automatically kill spoofers who use
// an illegal top level domain.
#undef KILL_ILLEGAL_TLD_DNS_SPOOFERS

// Controls whether bot should automatically kill spoofers who use
// illegal characters in their hostnames.
#define KILL_ILLEGAL_CHAR_SPOOFERS

// Controls whether bot should automatically kill spoofers who try
// to fake an unresolved IP address.
#define KILL_FAKE_IP_SPOOFERS

// Controls whether bot should automatically kick nick flooders and
// links lookers.
#define AUTO_KILL_NICK_FLOODING
#define AUTO_KILL_LINK_LOOKERS
#define AUTO_KILL_TRACE_LOOKERS
#define AUTO_KILL_MOTD_LOOKERS
#define AUTO_KILL_INFO_LOOKERS

#define NICK_CHANGE_T1_TIME  10
#define NICK_CHANGE_T2_TIME 300
#define NICK_CHANGE_MAX_COUNT 5

// Number of links looks to allow in number of seconds.
// We like 2 in 2 minutes, your mileage may vary.
#define MAX_LINK_LOOKS 2
#define MAX_LINK_TIME 600

// Number of trace looks to allow in number of seconds.
// We like 2 in 2 minutes, your mileage may vary.
#define MAX_TRACE_LOOKS 2
#define MAX_TRACE_TIME 600

// Number of motd looks to allow in number of seconds.
// We like 2 in 2 minutes, your mileage may vary.
#define MAX_MOTD_LOOKS 2
#define MAX_MOTD_TIME 600

// Number of info looks to allow in number of seconds.
// We like 2 in 2 minutes, your mileage may vary.
#define MAX_INFO_LOOKS 2
#define MAX_INFO_TIME 600

#define SERVICES
#define AUTOKSERVICES
#define AUTO_KLINE_SERVICES

#define SERVICES_NICK 		"x@services.us"
#define SERVICES_NAME		"services.us"

#undef CA_SERVICES
#define CA_SERVICES_NAME 	"services.ca"

// Disable this if BitchX users don't bother you.
#define BOOT_BITCHX









//////////////////////////////////////////////////////////////////////
//  Do not modify anything below this point
//////////////////////////////////////////////////////////////////////

// This is the version string :P
#define OOMON_VERSION		"1.2"

// Maximum buffer size
#define MAX_BUFF		1024

#define SMALL_BUFF		16

// Maximum hostname length
#define MAX_HOST		80

// Number of seconds to wait until timeout
#define SERVER_TIME_OUT		300

// Maximum number of DCC connections allowed
#define MAX_DCCS		100

// Maximum number of Remote connections allowed
#define MAX_REMOTES		100

// Maximum number of WinGate connections allowed
#define MAX_WINGATES		256

// Maximum number of Proxies connections allowed
#define MAX_PROXIES		256

// Number of seconds to wait before disconnecting an idle, unauthorized DCC
// connection
#define DCC_IDLE_MAX		60

// Number of seconds to wait before timing out a WinGate connection
//  1 - No data received yet
//  2 - Data received, waiting for "WinGate" text
#define WINGATE_IDLE_MAX_1	60
#define WINGATE_IDLE_MAX_2	5

// Number of seconds to wait before timing out a Proxy connection
#define PROXY_IDLE_MAX		120

#define MAX_NICK		10
#define MAX_USER		12
#define MAX_HOST		80
#define MAX_DOMAIN		80
#define MAX_IPADDR		15	/* 4 3-digit octets + 3 dots */
#define MAX_CLASS		32

#define MAXDOMAINS		2000

#define SERVICES_CLONE_THRESHOLD 	4
#define SERVICES_CHECK_TIME 		60

#define INVALID			(-1)

#ifdef HAVE_WHOIP
#undef HAVE_USRIP
#endif

#ifndef HAVE_USRIP
 #ifndef HAVE_WHOIP
  #define HAVE_STATSL
 #endif
#endif

#if defined (AUTO_KLINE) || defined (AUTO_KILL_NICK_FLOODING) ||\
 defined (AUTO_KILL_LINK_LOOKERS)
#define AUTOPILOT
#endif

#if !defined(HAVE_CRYPT) && defined(USE_CRYPT)
# undef USE_CRYPT
# warning "Couldn't find crypt()!  Using plaintext passwords instead."
#endif

#endif
