// $Id: util.h,v 1.14 2003/01/09 20:42:47 toast Exp $

#ifndef _UTIL_H_
#define _UTIL_H_

#include <string>

#include "strtype"

// Split tokenized (char *) into a StrVector
int StrSplit(StrVector &, std::string, const std::string &);

// Read a line of data from a socket (or whatever)
int ReadLine(register int, std::string &);

// Splits data from an IRC server into its pieces
int SplitIRC(StrVector &, std::string);

// Splits a nick!user@host into a nick and a user@host
void SplitFrom(std::string, std::string &, std::string &);

// Returns the nick in a nick!user@host thingy
std::string getNick(const std::string &);

// Convers an IRC command to an integer
int IRCCommand(const std::string &);

// Converts ASCII to an unsigned long
unsigned long atoul(const char *);

// Retrieves the first word in a string
std::string FirstWord(std::string &);

// Convers a DCC command to an integer
int DCCCommand(const std::string &);

// Converts a string to uppercase/lowercase
std::string UpCase(const std::string &);
std::string DownCase(const std::string &);

// Compares two strings (case-insensitive)
bool Same(std::string, std::string);

// Matches a user@host to a mask (case-insensitive)
bool MatchesMask(std::string, std::string);

// Compares two passwords
bool ChkPass(std::string, std::string);

// Returns a National Representation of the date and time
std::string TimeStamp();

// Returns a string representation of an integer
std::string IntToStr(int);
std::string ULongToStr(unsigned long);

int RemoteCommand(const std::string &);

std::string GetBotHB(std::string);
std::string GetHandleHB(std::string);

std::string::size_type CountChars(const std::string & text,
  const std::string::value_type ch);

std::string klineMask(const std::string & userhost);
std::string classCMask(const std::string & ip);

#define IRC_UNKNOWN	0
#define IRC_PING	1
#define IRC_NOTICE	2
#define IRC_PRIVMSG	3
#define IRC_WALLOPS	4

#endif
